Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 409315

Summary: sys-devel/gcc-4.7.0 version bump
Product: Gentoo Linux Reporter: Tolga Dalman <tdalman>
Component: [OLD] Core systemAssignee: Gentoo Toolchain Maintainers <toolchain>
Status: RESOLVED FIXED    
Severity: normal CC: 404errorqc, alecm_88, alexxy, anarchy, ansla80, anton.kochkov, axiator, bug, bugs+gentoo, bugzie, bureau, dark.knight.ita, darkdimius, dav.daemon, ddemidov, devurandom, didier-bugzillagentoo, duncanphilipnorman, eugene.shalygin, facorread, fedotov.i.f, fkrogh, gentoo-bugs, gmiramir, groggy, hardened, jaak, jcallen, jlp.bugs, jrmalaq, jtshs256, juggernautfin, kaikaikai, karl, kentnl, kredba, mail, marek.bartosiewicz, markieboy26, matrix47, mattst88, nimiux, oli.huber, orzel, pageexec, petr.behan, phantom4, poletti.marco, realnc, siarhei.siamashka, skrattaren, StormByte, sulinalex, supercilious.dude, xdudka00, zeekec
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on: 413425    
Bug Blocks:    
Attachments: gcc-4.7.0.build

Description Tolga Dalman 2012-03-22 13:25:14 UTC
Released today, please bump.
Comment 1 RedEyedMan 2012-03-28 16:48:37 UTC
Created attachment 307009 [details]
gcc-4.7.0.build

gcc-4.7.0.build, modified from latest gcc-4.7.0alpha ebuild (toolchain overlay
Comment 2 Ryan Hill (RETIRED) gentoo-dev 2012-04-03 05:07:11 UTC
There are some new linker plugin wrappers (gcc-{ar,nm,ranlib}) installed into gcc-bin that gcc-config might have to handle.  I'm not sure how they work or what their purpose is though.
Comment 3 SpanKY gentoo-dev 2012-04-03 16:52:06 UTC
maybe time for deploying the idea in bug 238984 comment 5 where the eclass populates a variable with all the binaries that gcc version is installing, and then gcc-config just uses that to figure out what to wrap ...
Comment 4 SpanKY gentoo-dev 2012-04-14 21:23:08 UTC
ok, no need for that as i've taken care of it in gcc-config-1.7

Ryan: can you make sure to include these fixes ?  they're already in the upstream gcc 4.7 branch.
http://lists.uclibc.org/pipermail/uclibc/2012-April/046658.html
Comment 5 Ryan Hill (RETIRED) gentoo-dev 2012-04-15 04:31:32 UTC
Yuuuuuup.

The gcc-config changes are working well.  Thanks!
Comment 6 Mark Wood 2012-04-16 05:49:32 UTC
So is this ready to roll now?
Comment 7 PaX Team 2012-04-17 20:14:37 UTC
what's the thinking about building the gcc binaries with gcc vs g++ (the latter's the default for boostrap)? this mostly affects gcc plugins and --disable-build-with-cxx controls it at configure time.
Comment 8 Ryan Hill (RETIRED) gentoo-dev 2012-04-23 02:50:24 UTC
To be honest I skipped that incredibly long thread on gcc-dev.  I think we'll follow upstream unless there's a compelling reason not to.
Comment 9 Magnus Granberg gentoo-dev 2012-04-24 23:19:11 UTC
(In reply to comment #8)
> To be honest I skipped that incredibly long thread on gcc-dev.  I think
> we'll follow upstream unless there's a compelling reason not to.

It affect #413425 (Hardened-kernel)
Comment 10 Matt Turner gentoo-dev 2012-05-02 04:25:48 UTC
Hey, I'll be happy to help get this out the door, if there's something I can do. Having 4.7.0 would help me greatly for some upstream gcc work.
Comment 11 Ryan Hill (RETIRED) gentoo-dev 2012-05-07 07:26:43 UTC
Mike, what's the status of x32 in 4.7?  Is it upstream or do we still have to patch it in?
Comment 12 SpanKY gentoo-dev 2012-05-08 18:05:22 UTC
(In reply to comment #11)

afaik, it should be in there, so drop it.  if there's something more i need, i'll add it after the fact.
Comment 13 Ryan Hill (RETIRED) gentoo-dev 2012-05-14 06:15:25 UTC
08_all_cross-compile.patch will have to be reworked.  The MD_UNWIND_SUPPORT macro has been removed and replaced with an auto-generated header.  See http://gcc.gnu.org/ml/gcc-patches/2011-05/msg02343.html.  It's probably just a case of figuring out where to move the inhibit_libc check.

The move of libgcc to toplevel means many of our patches don't apply.  I'm about halfway through them and hope to have this in the tree in the next couple days.
Comment 14 SpanKY gentoo-dev 2012-05-14 16:17:45 UTC
it can be dropped.  crossdev switched to --with-headers a long time ago making that unnecessary.  if i feel like resurrecting it, i'll do so after 4.7.0 is added to the tree, but i most likely won't bother.
Comment 15 SpanKY gentoo-dev 2012-05-14 16:20:49 UTC
i've queued that change to the 4.6.x and 4.7.x patchsets
Comment 16 Ryan Hill (RETIRED) gentoo-dev 2012-05-21 06:01:07 UTC
This is ready to go.  I'll push it out tomorrow.
Comment 17 Ryan Hill (RETIRED) gentoo-dev 2012-05-22 04:46:54 UTC
Bumped.  Thanks everyone.  I'm sorry about the wait.
Comment 18 Nikos Chantziaras 2012-05-22 05:30:21 UTC
(In reply to comment #17)
> Bumped.  Thanks everyone.  I'm sorry about the wait.

Thanks for continuing to work on it :-)

A quick question: is current policy about LTO still the same with 4.7?  (Meaning, use at your own risk and don't report bugs about it?)
Comment 19 Ryan Hill (RETIRED) gentoo-dev 2012-05-23 03:40:14 UTC
It says as much right when you emerge it. :)
Comment 20 Raymond Jennings 2012-09-21 07:15:23 UTC
Would I be correct to assume that lto problems should still be considered reportable directly to upstream?
Comment 21 Ryan Hill (RETIRED) gentoo-dev 2012-09-22 02:38:06 UTC
Yes but you may want to test a self-compiled vanilla version to make sure the bug is reproducible by upstream.
Comment 22 Ernst Herzberg 2012-09-22 09:25:34 UTC
New caveat found on gcc.gnu.org:

"GCC versions 4.7.0 and 4.7.1 had changes to the C++ standard library which affected the ABI in C++11 mode: a data member was added to std::list changing its size and altering the definitions of some member functions, and std::pair's move constructor was non-trivial which altered the calling convention for functions with std::pair arguments or return types. The ABI incompatibilities have been fixed for GCC version 4.7.2 but as a result C++11 code compiled with GCC 4.7.0 or 4.7.1 may be incompatible with C++11 code compiled with different GCC versions and with C++98/C++03 code compiled with any version."
Comment 23 Ryan Hill (RETIRED) gentoo-dev 2012-09-22 22:17:12 UTC
Okay let's stop replying to this bug now.